#include "main.h"

Widget PrintFile_Text;
Widget PrintLpr_Text;
Widget PrintFile_Toggle;
Widget PrintLpr_Toggle;
Widget PrintFile_Label;
Widget PrintLpr_Label;

void Print_Close(Widget   w,
		 Widget   PopupWidget, 
		 XmAnyCallbackStruct *call_value)
{
  XtUnrealizeWidget(PopupWidget);
}

void Lpr_Toggle_Callback(Widget   w,
			 Widget   PopupWidget, 
			 XmAnyCallbackStruct *call_value)
{
  XtSetSensitive(PrintLpr_Text,True);
  XtSetSensitive(PrintLpr_Label,True);
  XtSetSensitive(PrintFile_Label,False);
  XtSetSensitive(PrintFile_Text,False);
}

void File_Toggle_Callback(Widget   w,
			 Widget   PopupWidget, 
			 XmAnyCallbackStruct *call_value)
{
  XtSetSensitive(PrintFile_Text,True);
  XtSetSensitive(PrintFile_Label,True);
  XtSetSensitive(PrintLpr_Label,False);
  XtSetSensitive(PrintLpr_Text,False);
}

void Print_Confirm(Widget   w,
		   Widget   PopupWidget, 
		   XmAnyCallbackStruct *call_value)
{
  FILE *PrintFile;
  char *PrintStr = (char *)NULL;
  Calendar_Type *Temp;
  int Counter=0;
  int PageNumber = 1;
  struct passwd *PasswdRec;

  if (G_CalendarList == NULL)
    {
      XtFree(PrintStr);
      return;
    }
  if ((PasswdRec = getpwuid(getuid())) == NULL)
    {
      perror("getpwuid");
      return;
    }
  if (XmToggleButtonGetState(PrintLpr_Toggle) == True)
    {
      PrintStr = XmTextFieldGetString(PrintLpr_Text);
      if ((PrintFile = popen(PrintStr,"w")) == NULL)
	{
	  perror(PrintStr);
	  return;
	}
    }
    else {
      PrintStr = XmTextFieldGetString(PrintFile_Text);
      if ((PrintFile = fopen(PrintStr,"w")) == NULL)
	{
	  perror(PrintStr);
	  return;
	}
    }
    
  fprintf(PrintFile,"%%!\n%% Created By: %s\n",PROGRAM_TITLE);
  fprintf(PrintFile,"%%!\n%% Created On: %s\n",Get_Current_Date_Time("%X %x"));
  if (XmToggleButtonGetState(PrintLpr_Toggle) == True)
    {
      pclose(PrintFile);
    }
  else {
      pclose(PrintFile);
  }
  XtUnrealizeWidget(PopupWidget);
}



void Print_Reset(Widget   w,
		  Widget   TextWidget, 
		  XmAnyCallbackStruct *call_value)
{
  XmTextFieldSetString(PrintLpr_Text,DEFAULT_PRINT_COMMAND);
  XmTextFieldSetString(PrintFile_Text,DEFAULT_PRINT_FILENAME);
  XmToggleButtonSetState(PrintLpr_Toggle,True,True);
  XtSetSensitive(PrintLpr_Text,True);
  XtSetSensitive(PrintLpr_Label,True);
  XtSetSensitive(PrintFile_Label,False);
  XtSetSensitive(PrintFile_Text,False);
}



void  Print_Calendar(Widget   w,
		     Widget   textwidget,   
		     XmAnyCallbackStruct *call_value)
{
  Widget Print_Popup;
  Widget Print_Frame;
  Widget Print_Form;
  Widget Print_RC1;
  Widget Print_RC2;
  Widget Print_Separator;
  Widget PrintConfirm_Button;
  Widget PrintReset_Button;
  Widget PrintClose_Button;
  Widget PrintYearly_Toggle;
  Widget PrintMonthly_Toggle;
  Widget PrintDaily_Toggle;
  XmString LabelString;
  Atom WM_DELETE_WINDOW;
  
  Print_Popup = XtVaAppCreateShell("Print_Popup",
				   "Print_Popup",
				   applicationShellWidgetClass,
				   XtDisplay(W_TopLevel),
				   XmNtitle, "Print",
				   XmNdeleteResponse, XmDO_NOTHING,
				   NULL,0); 
  
  Print_Frame = XtVaCreateManagedWidget("Print_Window",
					xmFrameWidgetClass, 
					Print_Popup,
					NULL,0);
  
  Print_Form = XtVaCreateManagedWidget("Print_Form",
				       xmFormWidgetClass, 
				       Print_Frame,
				       NULL,0);
  
  Print_RC1 = XtVaCreateManagedWidget("Print_RC",
				      xmRowColumnWidgetClass, 
				      Print_Form,
				      XmNleftAttachment, XmATTACH_FORM,
				      XmNleftOffset, 10,
				      XmNrightAttachment, XmATTACH_FORM,
				      XmNrightOffset, 10,
				      XmNtopAttachment, XmATTACH_FORM,
				      XmNtopOffset, 10,
				      XmNentryAlignment, XmALIGNMENT_END,
				      XmNorientation, XmHORIZONTAL,
				      XmNpacking, XmPACK_TIGHT,
				      XmNradioBehavior, True,
				      NULL,0);
   
 LabelString = XmStringCreate("Print Yearly View", XmSTRING_DEFAULT_CHARSET),
  PrintYearly_Toggle = XtVaCreateManagedWidget("PrintYearly_Toggle",
					       xmToggleButtonWidgetClass, 
					       Print_RC1,
					       XmNlabelString, LabelString,
					       NULL,0);
  XmStringFree(LabelString);
  LabelString = XmStringCreate("Print Monthly View", XmSTRING_DEFAULT_CHARSET),
  PrintMonthly_Toggle = XtVaCreateManagedWidget("PrintMonthly_Toggle",
						xmToggleButtonWidgetClass, 
						Print_RC1,
						XmNlabelString, LabelString,
						NULL,0);
  XmStringFree(LabelString);
  LabelString = XmStringCreate("Print Daily Appointments", XmSTRING_DEFAULT_CHARSET),
  PrintDaily_Toggle = XtVaCreateManagedWidget("PrintDaily_Toggle",
					      xmToggleButtonWidgetClass, 
					      Print_RC1,
					      XmNlabelString, LabelString,
					      NULL,0);
  XmStringFree(LabelString);

  Print_RC2 = XtVaCreateManagedWidget("Print_RC",
				      xmRowColumnWidgetClass, 
				      Print_Form,
				      XmNleftAttachment, XmATTACH_FORM,
				      XmNleftOffset, 10,
				      XmNrightAttachment, XmATTACH_FORM,
				      XmNrightOffset, 10,
				      XmNtopAttachment, XmATTACH_WIDGET,
				      XmNtopOffset, 10,
				      XmNtopWidget, Print_RC1,
				      XmNentryAlignment, XmALIGNMENT_END,
				      XmNorientation, XmHORIZONTAL,
				      XmNpacking, XmPACK_TIGHT,
				      XmNradioBehavior, True,
				      NULL,0);
  
  LabelString = XmStringCreate("Output to a Printer", XmSTRING_DEFAULT_CHARSET),
  PrintLpr_Toggle = XtVaCreateManagedWidget("PrintLpr_Toggle",
					    xmToggleButtonWidgetClass, 
					    Print_RC2,
					    XmNlabelString, LabelString,
					    NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(PrintLpr_Toggle, XmNarmCallback, 
                (XtCallbackProc) Lpr_Toggle_Callback, Print_Popup);
  XmToggleButtonSetState(PrintLpr_Toggle,True,True);

  LabelString = XmStringCreate("Output to a File", XmSTRING_DEFAULT_CHARSET),
  PrintFile_Toggle = XtVaCreateManagedWidget("PrintFile_Toggle",
					     xmToggleButtonWidgetClass, 
					     Print_RC2,
					     XmNlabelString, LabelString,
					     NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(PrintFile_Toggle, XmNarmCallback, 
                (XtCallbackProc) File_Toggle_Callback, Print_Popup);

  LabelString = XmStringCreate("Print Command: ", XmSTRING_DEFAULT_CHARSET),
  PrintLpr_Label = XtVaCreateManagedWidget("PrintLpr_Label",
					   xmLabelWidgetClass, 
					   Print_Form,
					   XmNlabelString, LabelString,
					   XmNleftAttachment, XmATTACH_FORM,
					   XmNleftOffset, 10,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopOffset, 10,
					   XmNtopWidget, Print_RC2,
					   NULL,0);
  XmStringFree(LabelString);
  
  PrintLpr_Text = XtVaCreateManagedWidget("PrintLpr_Text",
					  xmTextFieldWidgetClass, 
					  Print_Form,
					  XmNcolumns, 60,
					  XmNleftAttachment, XmATTACH_WIDGET,
					  XmNleftOffset, 10,
					  XmNleftWidget, PrintLpr_Label,
					  XmNrightAttachment, XmATTACH_FORM,
					  XmNrightOffset, 10,
					  XmNtopAttachment, XmATTACH_WIDGET,
					  XmNtopOffset, 10,
					  XmNtopWidget, Print_RC2,
					  NULL,0);
  XtAddCallback(PrintLpr_Text, XmNactivateCallback, 
                (XtCallbackProc) Print_Confirm, Print_Popup);
  XmTextFieldSetString(PrintLpr_Text,DEFAULT_PRINT_COMMAND);
  

  LabelString = XmStringCreate("Filename: ", XmSTRING_DEFAULT_CHARSET),
  PrintFile_Label = XtVaCreateManagedWidget("PrintFile_Label",
					    xmLabelWidgetClass, 
					    Print_Form,
					    XmNlabelString, LabelString,
					    XmNleftAttachment, XmATTACH_FORM,
					    XmNleftOffset, 10,
					    XmNtopAttachment, XmATTACH_WIDGET,
					    XmNtopOffset, 10,
					    XmNtopWidget, PrintLpr_Text,
					    NULL,0);
  XmStringFree(LabelString);
  XtSetSensitive(PrintFile_Label,False);
  
  PrintFile_Text = XtVaCreateManagedWidget("PrintFile_Text",
					   xmTextFieldWidgetClass, 
					   Print_Form,
					   XmNcolumns, 60,
					   XmNleftAttachment, XmATTACH_WIDGET,
					   XmNleftOffset, 10,
					   XmNleftWidget, PrintFile_Label,
					   XmNrightAttachment, XmATTACH_FORM,
					   XmNrightOffset, 10,
					   XmNtopAttachment, XmATTACH_WIDGET,
					   XmNtopOffset, 10,
					   XmNtopWidget, PrintLpr_Text,
					   NULL,0);
  XtAddCallback(PrintFile_Text, XmNactivateCallback, 
                (XtCallbackProc) Print_Confirm, Print_Popup);
  XmTextFieldSetString(PrintFile_Text,DEFAULT_PRINT_FILENAME);
  XtSetSensitive(PrintFile_Text,False);

  Print_Separator = XtVaCreateManagedWidget("Print_Separator",
					    xmSeparatorWidgetClass,
					    Print_Form,
					    XmNtopAttachment, XmATTACH_WIDGET, 
					    XmNtopWidget, PrintFile_Text,
					    XmNtopOffset, 10,
					    XmNleftAttachment, XmATTACH_FORM,
					    XmNrightAttachment, XmATTACH_FORM,
					    NULL,0);
  
  LabelString = XmStringCreate("Print", XmSTRING_DEFAULT_CHARSET),
  PrintConfirm_Button = XtVaCreateManagedWidget("PrintConfirm_Button",
						xmPushButtonWidgetClass,
						Print_Form,
						XmNlabelString, LabelString,
						XmNtopAttachment, XmATTACH_WIDGET, 
						XmNbottomAttachment, XmATTACH_FORM,
						XmNtopWidget, Print_Separator,
						XmNtopOffset, 10,
						XmNbottomOffset, 10,
						XmNleftAttachment, XmATTACH_POSITION,
						XmNleftPosition,25,
						NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(PrintConfirm_Button, XmNactivateCallback, 
                (XtCallbackProc) Print_Confirm, Print_Popup);
  
  
  LabelString = XmStringCreate("Reset", XmSTRING_DEFAULT_CHARSET),
  PrintReset_Button = XtVaCreateManagedWidget("PrintReset_Button",
					      xmPushButtonWidgetClass,
					      Print_Form,
					      XmNlabelString, LabelString,
					      XmNtopAttachment, XmATTACH_WIDGET, 
					      XmNbottomAttachment, XmATTACH_FORM,
					      XmNtopWidget, Print_Separator,
					      XmNtopOffset, 10,
					      XmNbottomOffset, 10,
					      XmNleftAttachment, XmATTACH_POSITION,
					      XmNleftPosition,50,
					      NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(PrintReset_Button, XmNactivateCallback, 
                (XtCallbackProc) Print_Reset, NULL);
  
  
  LabelString = XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET),
  PrintClose_Button = XtVaCreateManagedWidget("PrintClose_Button",
					      xmPushButtonWidgetClass,
					      Print_Form,
					      XmNlabelString, LabelString,
					      XmNtopAttachment, XmATTACH_WIDGET, 
					      XmNbottomAttachment, XmATTACH_FORM,
					      XmNtopWidget, Print_Separator,
					      XmNtopOffset, 10,
					      XmNbottomOffset, 10,
					      XmNleftAttachment, XmATTACH_POSITION,
					      XmNleftPosition,75,
					      NULL,0);
  XmStringFree(LabelString);
  XtAddCallback(PrintClose_Button, XmNactivateCallback, 
                (XtCallbackProc) Print_Close, Print_Popup );

  WM_DELETE_WINDOW = XmInternAtom(XtDisplay(Print_Popup),"WM_DELETE_WINDOW",False);
  XmAddWMProtocolCallback(Print_Popup,WM_DELETE_WINDOW,
			  (XtCallbackProc)Print_Close,Print_Popup);
  
  XtRealizeWidget(Print_Popup);
}

